import CodeMirror from 'codemirror';
import { Justification, SourceLocation } from 'tutch';
/**
 * Create a Tutch CodeMirror element.
 *
 * CodeMirror itself is a big honkin' thing. Sometimes you want to just load
 * `codemirror.js`, sometimes you want to import codemirror and have webpack
 * take care of it. I don't know which one is better, so whatever you do, just
 * pass the `CodeMirror` builder object to the function.
 *
 * The optional text is the initial program,
 */
export default function TutchCode(options: {
    url: string;
    host: HTMLElement;
    codemirror: (host: HTMLElement, options: CodeMirror.EditorConfiguration) => CodeMirror.Editor;
    text?: string;
    onSuccess?: (justs: Justification[]) => void;
    onError?: (errorMessage: string, loc: SourceLocation | null) => void;
    onUpdate?: (text: string) => void;
}): void;
